package jpass.smartcard;

public class CardsManager {
    private static CardsManager instance = null;
    private JavaCard card = null;
    
    protected CardsManager() {
        
    }
    
    public static CardsManager getInstance() {
        if(instance == null) {
           instance = new CardsManager();
        }
        return instance;
    }
    
    public boolean initalizeCard() {
        if (this.card != null) {
            return true;
        }
        try {
            this.card = new JavaCard(true); // true - simulator, false - card
        } catch (Exception ex) {
            System.out.println("Exception : " + ex);
            return false;
        }
        return true;
    }
        
    public JavaCard getActiveCard() {
        return this.card;
    }
    
    public boolean isPinUnlocked() {
        return this.getActiveCard().isPinUnlocked();
    }
    
    public boolean setPin(byte[] pin) {
        return this.getActiveCard().setPin(pin);
    }
    
    public boolean verifyPin(byte[] pin) {
        return this.getActiveCard().verifyPin(pin);
    }
    
    public byte[] encryptBytes(byte[] IV, byte[] data) throws Exception {
        return this.getActiveCard().encryptBytes(IV, data);
    }
    
    public byte[] decryptBytes(byte[] IV, byte[] data) throws Exception {
        return this.getActiveCard().decryptBytes(IV, data);
    }
    
    public byte[] testSecure(byte[] data) throws Exception {
        return this.getActiveCard().testSecure(data);
    }
    
    public boolean dhInit() throws Exception {
        return this.getActiveCard().dhInit();
    }
    
    public byte[] dhGet() throws Exception {
        return this.getActiveCard().dhGet();
    }
    
    public byte[] dhGet2() throws Exception {
        return this.getActiveCard().dhGet2();
    }
    
    public boolean dhSetY(byte[] data) throws Exception {
        return this.getActiveCard().dhSetY(data);
    }
    
    public byte[] dhDoFinal() throws Exception {
        return this.getActiveCard().dhDoFinal();
    }
    
    public byte[] dhTest() throws Exception {
        return this.getActiveCard().dhTest();
    }
}
